class = require("lib/middleclass")
tiny = require("lib/tiny")
local gamera = require("lib/gamera")
local sti = require("lib/sti")
local camera = nil

local tileMap = nil
local world = nil

function love.load()
	tileMap = sti("assets/badshore.lua")
	camera = gamera.new(0,0,tileMap.width*tileMap.tilewidth, tileMap.height*tileMap.tileheight)
	world = tiny.world(
		require("src.PlayerControlSystem")(tileMap),
		require("src.CameraTrackingSystem")(camera),
		require("src.TileMapRenderSystem")(tileMap, camera),
		require("src.SpriteSystem")(),
		require("src.Player")({x=200, y=200})
	)
end

function love.update(dt)
	-- if camera then
	-- 	print(camera:getPosition())
	-- end
	-- tileMap:update(dt)
end

function love.draw()
	-- tileMap:draw()
	local dt = love.timer.getDelta()
	if world then
		world:update(dt)
	end
end

function love.keypressed(key, code)
	if key == "escape" then
		love.event.push("quit")
	end
end