local PlayerControlSystem = tiny.processingSystem(class "PlayerControlSystem")

PlayerControlSystem.filter = tiny.requireAll("controllable", "position", "speed")

function PlayerControlSystem:initialize(tileMap)
	-- local layer = tileMap.layers["Sprites"]
	self.atStart = true
	self.start = {x=0, y=0}
	
	for k, object in pairs(tileMap.objects) do
		if object.name == "Player" then
			self.start.x = object.x
			self.start.y = object.y
			print("location: "..object.x..", "..object.y)
			break
		end
	end

    -- if layer.type == "objectgroup" then
    --     for _, object in ipairs(layer.objects) do
    --         local ctor = require("src.entities." .. object.type)
    --         local e = ctor(object)
    --         if object.type == "Player" then
    --             player = e
    --         end
    --         world:add(e)
    --     end
    --     tileMap:removeLayer(lindex)
    -- end

		-- for _, sprite in pairs(self.sprites) do
		-- 	local x = math.floor(sprite.x)
		-- 	local y = math.floor(sprite.y)
		-- 	local r = sprite.r
		-- 	-- print(sprite.image)
		-- 	love.graphics.draw(sprite.image, x, y, r, 1, 1)
		-- 	love.graphics.rectangle("line", sprite.x, sprite.y, sprite.image:getWidth(), sprite.image:getHeight())
		-- end
end

function PlayerControlSystem:process(player, dt)
	if self.atStart then
		player.position = self.start
	end

	local dx, dy = 0, 0

	if love.keyboard.isDown("w", "a", "s", "d", "up", "down", "left", "right") then
		self.atStart = false
	end

	if love.keyboard.isDown("w", "up") then
		dy = dy - player.speed * dt
	end
	if love.keyboard.isDown("s", "down") then
		dy = dy + player.speed * dt
	end
	if love.keyboard.isDown("a", "left") then
		dx = dx - player.speed * dt
	end
	if love.keyboard.isDown("d", "right") then
		dx = dx + player.speed * dt
	end

	if dx ~= 0 and dy ~= 0 then
		dx = dx * 0.707106781
		dy = dy * 0.707106781
	end

	player.position.x = player.position.x + dx
	player.position.y = player.position.y + dy

	-- print("speed: "..player.speed..", pos: "..player.position.x..", "..player.position.y)

end

return PlayerControlSystem